import { CloseCallback, OpenCallback, Options, SignalIndicator, SignalListener } from './typedef';
export declare class WebSocketService<Req, Res, Err, SReq = Req, DRes = Res> {
    #private;
    constructor(options: Options<Req, Res, Err, SReq, DRes>, openCallback?: OpenCallback, closeCallback?: CloseCallback);
    open: () => void;
    send: (data: Req) => void;
    close: (code?: number | undefined) => void;
    addSignalListener: (indicator: SignalIndicator, listener: SignalListener<DRes, Err>) => () => void;
    removeSignalListener: (indicator: SignalIndicator, targetId: string) => void;
}
